Scala Standard Library2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
    - `scala.collection.parallel.immutable` - Immutable, parallel data-structures such as `ParVector`, `ParRange`, `ParHashMap` or `ParHashSet`
    - `scala.collection.parallel.mutable` - Mutable, parallel data-structures such as `ParArray`, `ParHashMap`, `ParTrieMap` or `ParHashSet`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package collection

  Contains the base traits and objects needed to use and extend Scala's collection library.

  Contains the base traits and objects needed to use and extend Scala's collection library.

  #### Guide

  A detailed guide for using the collections library is available at http://docs.scala-lang.org/overviews/collections/introduction.html. Developers looking to extend the collections library can find a description of its architecture at http://docs.scala-lang.org/overviews/core/architecture-of-scala-collections.html.

  #### Using Collections

  It is convenient to treat all collections as either a scala.collection.Traversable or scala.collection.Iterable, as these traits define the vast majority of operations on a collection.

  Collections can, of course, be treated as specifically as needed, and the library is designed to ensure that the methods that transform collections will return a collection of the same type:

      scala> val array = Array(1,2,3,4,5,6)
      array: Array[Int] = Array(1, 2, 3, 4, 5, 6)

      scala> array map { _.toString }
      res0: Array[String] = Array(1, 2, 3, 4, 5, 6)

      scala> val list = List(1,2,3,4,5,6)
      list: List[Int] = List(1, 2, 3, 4, 5, 6)

      scala> list map { _.toString }
      res1: List[String] = List(1, 2, 3, 4, 5, 6)

  #### Creating Collections

  The most common way to create a collection is to use its companion object as a factory. The three most commonly used collections are scala.collection.Seq, scala.collection.immutable.Set, and scala.collection.immutable.Map. They can be used directly as shown below since their companion objects are all available as type aliases in either the scala package or in `scala.Predef`. New collections are created like this:

      scala> val seq = Seq(1,2,3,4,1)
      seq: Seq[Int] = List(1, 2, 3, 4, 1)

      scala> val set = Set(1,2,3,4,1)
      set: scala.collection.immutable.Set[Int] = Set(1, 2, 3, 4)

      scala> val map = Map(1 -> "one", 2 -> "two", 3 -> "three", 2 -> "too")
      map: scala.collection.immutable.Map[Int,String] = Map(1 -> one, 2 -> too, 3 -> three)

  It is also typical to prefer the scala.collection.immutable collections over those in scala.collection.mutable; the types aliased in the `scala.Predef` object are the immutable versions.

  Also note that the collections library was carefully designed to include several implementations of each of the three basic collection types. These implementations have specific performance characteristics which are described in the guide.

  The concrete parallel collections also have specific performance characteristics which are described in the parallel collections guide

  ##### Converting to and from Java Collections

  The scala.collection.JavaConverters object provides a collection of decorators that allow converting between Scala and Java collections using `asScala` and `asJava` methods.

  Definition Classes
    scala
-  package concurrent
  Definition Classes
    collection
-  package convert
  Definition Classes
    collection
-  package generic
  Definition Classes
    collection
-  package immutable
  Definition Classes
    collection
-  package mutable
  Definition Classes
    collection
-  package parallel

  Package object for parallel collections.

  Package object for parallel collections.

  Definition Classes
    collection
-  package script
  Definition Classes
    collection
- +:
- :+
- AbstractIterable
- AbstractIterator
- AbstractMap
- AbstractSeq
- AbstractSet
- AbstractTraversable
- BitSet
- BitSetLike
- BufferedIterator
- CustomParallelizable
- DefaultMap
- GenIterable
- GenIterableLike
- GenMap
- GenMapLike
- GenSeq
- GenSeqLike
- GenSet
- GenSetLike
- GenTraversable
- GenTraversableLike
- GenTraversableOnce
- IndexedSeq
- IndexedSeqLike
- IndexedSeqOptimized
- Iterable
- IterableLike
- IterableProxy
- IterableProxyLike
- IterableView
- IterableViewLike
- Iterator
- JavaConversions
- JavaConverters
- LinearSeq
- LinearSeqLike
- LinearSeqOptimized
- Map
- MapLike
- MapProxy
- MapProxyLike
- Parallel
- Parallelizable
- Searching
- Seq
- SeqLike
- SeqProxy
- SeqProxyLike
- SeqView
- SeqViewLike
- Set
- SetLike
- SetProxy
- SetProxyLike
- SortedMap
- SortedMapLike
- SortedSet
- SortedSetLike
- Traversable
- TraversableLike
- TraversableOnce
- TraversableProxy
- TraversableProxyLike
- TraversableView
- TraversableViewLike
- ViewMkString

o

scala.collection

# JavaConversions 

###

#### object JavaConversions extends WrapAsScala with WrapAsJava

A variety of implicit conversions supporting interoperability between Scala and Java collections.

The following conversions are supported:

    scala.collection.Iterable       <=> java.lang.Iterable
    scala.collection.Iterable       <=> java.util.Collection
    scala.collection.Iterator       <=> java.util.{ Iterator, Enumeration }
    scala.collection.mutable.Buffer <=> java.util.List
    scala.collection.mutable.Set    <=> java.util.Set
    scala.collection.mutable.Map    <=> java.util.{ Map, Dictionary }
    scala.collection.concurrent.Map <=> java.util.concurrent.ConcurrentMap

In all cases, converting from a source type to a target type and back again will return the original source object:

    import scala.collection.JavaConversions._

    val sl = new scala.collection.mutable.ListBuffer[Int]
    val jl : java.util.List[Int] = sl
    val sl2 : scala.collection.mutable.Buffer[Int] = jl
    assert(sl eq sl2)

In addition, the following one way conversions are provided:

    scala.collection.Seq         => java.util.List
    scala.collection.mutable.Seq => java.util.List
    scala.collection.Set         => java.util.Set
    scala.collection.Map         => java.util.Map
    java.util.Properties         => scala.collection.mutable.Map[String, String]

The transparent conversions provided here are considered fragile because they can result in unexpected behavior and performance.

Therefore, this API has been deprecated and `JavaConverters` should be used instead. `JavaConverters` provides the same conversions, but through extension methods.

Annotations
  @deprecated
Deprecated

  (Since version 2.12.0) use JavaConverters

Source
  JavaConversions.scala
Since

  2.8

Linear Supertypes
WrapAsJava, LowPriorityWrapAsJava, WrapAsScala, LowPriorityWrapAsScala, AnyRef, Any
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. JavaConversions
2. WrapAsJava
3. LowPriorityWrapAsJava
4. WrapAsScala
5. LowPriorityWrapAsScala
6. AnyRef
7. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any
2.  final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
4.  final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

5.  implicit def asJavaCollection[A](it: Iterable[A]): Collection[A]

   Implicitly converts a Scala Iterable to an immutable Java Collection.

   Implicitly converts a Scala Iterable to an immutable Java Collection.

   If the Scala Iterable was previously obtained from an implicit or explicit call of `asSizedIterable(java.util.Collection)` then the original Java Collection will be returned.

   it

     The SizedIterable to be converted.

   returns

     A Java Collection view of the argument.

   Definition Classes
     LowPriorityWrapAsJava
6.  implicit def asJavaDictionary[A, B](m: mutable.Map[A, B]): Dictionary[A, B]

   Implicitly converts a Scala mutable `Map` to a Java `Dictionary`.

   Implicitly converts a Scala mutable `Map` to a Java `Dictionary`.

   The returned Java `Dictionary` is backed by the provided Scala `Dictionary` and any side-effects of using it via the Java interface will be visible via the Scala interface and vice versa.

   If the Scala `Dictionary` was previously obtained from an implicit or explicit call of `asMap(java.util.Dictionary)` then the original Java Dictionary will be returned.

   m

     The `Map` to be converted.

   returns

     A Java `Dictionary` view of the argument.

   Definition Classes
     LowPriorityWrapAsJava
7.  implicit def asJavaEnumeration[A](it: Iterator[A]): java.util.Enumeration[A]

   Implicitly converts a Scala Iterator to a Java Enumeration.

   Implicitly converts a Scala Iterator to a Java Enumeration. The returned Java Enumeration is backed by the provided Scala Iterator and any side-effects of using it via the Java interface will be visible via the Scala interface and vice versa.

   If the Scala Iterator was previously obtained from an implicit or explicit call of `asIterator(java.util.Enumeration)` then the original Java Enumeration will be returned.

   it

     The Iterator to be converted.

   returns

     A Java Enumeration view of the argument.

   Definition Classes
     LowPriorityWrapAsJava
8.  implicit def asJavaIterable[A](i: Iterable[A]): java.lang.Iterable[A]

   Implicitly converts a Scala Iterable to a Java Iterable.

   Implicitly converts a Scala Iterable to a Java Iterable. The returned Java Iterable is backed by the provided Scala Iterable and any side-effects of using it via the Java interface will be visible via the Scala interface and vice versa.

   If the Scala Iterable was previously obtained from an implicit or explicit call of `asIterable(java.lang.Iterable)` then the original Java Iterable will be returned.

   i

     The Iterable to be converted.

   returns

     A Java Iterable view of the argument.

   Definition Classes
     LowPriorityWrapAsJava
9.  implicit def asJavaIterator[A](it: Iterator[A]): java.util.Iterator[A]

   Implicitly converts a Scala Iterator to a Java Iterator.

   Implicitly converts a Scala Iterator to a Java Iterator. The returned Java Iterator is backed by the provided Scala Iterator and any side-effects of using it via the Java interface will be visible via the Scala interface and vice versa.

   If the Scala Iterator was previously obtained from an implicit or explicit call of `asIterator(java.util.Iterator)` then the original Java Iterator will be returned.

   it

     The Iterator to be converted.

   returns

     A Java Iterator view of the argument.

   Definition Classes
     LowPriorityWrapAsJava
10.  implicit def asScalaBuffer[A](l: java.util.List[A]): Buffer[A]

    Implicitly converts a Java `List` to a Scala mutable `Buffer`.

    Implicitly converts a Java `List` to a Scala mutable `Buffer`.

    The returned Scala `Buffer` is backed by the provided Java `List` and any side-effects of using it via the Scala interface will be visible via the Java interface and vice versa.

    If the Java `List` was previously obtained from an implicit or explicit call of `asScalaBuffer(scala.collection.mutable.Buffer)` then the original Scala `Buffer` will be returned.

    l

      The `List` to be converted.

    returns

      A Scala mutable `Buffer` view of the argument.

    Definition Classes
      LowPriorityWrapAsScala
11.  implicit def asScalaIterator[A](it: java.util.Iterator[A]): Iterator[A]

    Implicitly converts a Java `Iterator` to a Scala `Iterator`.

    Implicitly converts a Java `Iterator` to a Scala `Iterator`.

    The returned Scala `Iterator` is backed by the provided Java `Iterator` and any side-effects of using it via the Scala interface will be visible via the Java interface and vice versa.

    If the Java `Iterator` was previously obtained from an implicit or explicit call of `asIterator(scala.collection.Iterator)` then the original Scala `Iterator` will be returned.

    it

      The `Iterator` to be converted.

    returns

      A Scala `Iterator` view of the argument.

    Definition Classes
      LowPriorityWrapAsScala
12.  implicit def asScalaSet[A](s: java.util.Set[A]): mutable.Set[A]

    Implicitly converts a Java Set to a Scala mutable Set.

    Implicitly converts a Java Set to a Scala mutable Set. The returned Scala Set is backed by the provided Java Set and any side-effects of using it via the Scala interface will be visible via the Java interface and vice versa.

    If the Java Set was previously obtained from an implicit or explicit call of `asScalaSet(scala.collection.mutable.Set)` then the original Scala Set will be returned.

    s

      The Set to be converted.

    returns

      A Scala mutable Set view of the argument.

    Definition Classes
      LowPriorityWrapAsScala
13.  implicit def bufferAsJavaList[A](b: Buffer[A]): java.util.List[A]

    Implicitly converts a Scala mutable Buffer to a Java List.

    Implicitly converts a Scala mutable Buffer to a Java List. The returned Java List is backed by the provided Scala Buffer and any side-effects of using it via the Java interface will be visible via the Scala interface and vice versa.

    If the Scala Buffer was previously obtained from an implicit or explicit call of `asBuffer(java.util.List)` then the original Java List will be returned.

    b

      The Buffer to be converted.

    returns

      A Java List view of the argument.

    Definition Classes
      LowPriorityWrapAsJava
14.  def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

15.  implicit def collectionAsScalaIterable[A](i: Collection[A]): Iterable[A]

    Implicitly converts a Java `Collection` to an Scala `Iterable`.

    Implicitly converts a Java `Collection` to an Scala `Iterable`.

    If the Java `Collection` was previously obtained from an implicit or explicit call of `collectionAsScalaIterable(scala.collection.SizedIterable)` then the original Scala `Iterable` will be returned.

    i

      The Collection to be converted.

    returns

      A Scala Iterable view of the argument.

    Definition Classes
      LowPriorityWrapAsScala
16.  implicit def deprecated asJavaCollection[A](it: Iterable[A]): Collection[A]
    Definition Classes
      WrapAsJava
17.  implicit def deprecated asJavaDictionary[A, B](m: mutable.Map[A, B]): Dictionary[A, B]
    Definition Classes
      WrapAsJava
18.  implicit def deprecated asJavaEnumeration[A](it: Iterator[A]): java.util.Enumeration[A]
    Definition Classes
      WrapAsJava
19.  implicit def deprecated asJavaIterable[A](i: Iterable[A]): java.lang.Iterable[A]
    Definition Classes
      WrapAsJava
20.  implicit def deprecated asJavaIterator[A](it: Iterator[A]): java.util.Iterator[A]
    Definition Classes
      WrapAsJava
21.  implicit def deprecated asScalaBuffer[A](l: java.util.List[A]): Buffer[A]
    Definition Classes
      WrapAsScala
22.  implicit def deprecated asScalaIterator[A](it: java.util.Iterator[A]): Iterator[A]
    Definition Classes
      WrapAsScala
23.  implicit def deprecated asScalaSet[A](s: java.util.Set[A]): mutable.Set[A]
    Definition Classes
      WrapAsScala
24.  implicit def deprecated bufferAsJavaList[A](b: Buffer[A]): java.util.List[A]
    Definition Classes
      WrapAsJava
25.  implicit def deprecated collectionAsScalaIterable[A](i: Collection[A]): Iterable[A]
    Definition Classes
      WrapAsScala
26.  implicit def deprecated dictionaryAsScalaMap[A, B](p: Dictionary[A, B]): mutable.Map[A, B]
    Definition Classes
      WrapAsScala
27.  implicit def deprecated enumerationAsScalaIterator[A](i: java.util.Enumeration[A]): Iterator[A]
    Definition Classes
      WrapAsScala
28.  implicit def deprecated iterableAsScalaIterable[A](i: java.lang.Iterable[A]): Iterable[A]
    Definition Classes
      WrapAsScala
29.  implicit def deprecated mapAsJavaConcurrentMap[A, B](m: concurrent.Map[A, B]): ConcurrentMap[A, B]
    Definition Classes
      WrapAsJava
30.  implicit def deprecated mapAsJavaMap[A, B](m: Map[A, B]): java.util.Map[A, B]
    Definition Classes
      WrapAsJava
31.  implicit def deprecated mapAsScalaConcurrentMap[A, B](m: ConcurrentMap[A, B]): concurrent.Map[A, B]
    Definition Classes
      WrapAsScala
32.  implicit def deprecated mapAsScalaMap[A, B](m: java.util.Map[A, B]): mutable.Map[A, B]
    Definition Classes
      WrapAsScala
33.  implicit def deprecated mutableMapAsJavaMap[A, B](m: mutable.Map[A, B]): java.util.Map[A, B]
    Definition Classes
      WrapAsJava
34.  implicit def deprecated mutableSeqAsJavaList[A](seq: mutable.Seq[A]): java.util.List[A]
    Definition Classes
      WrapAsJava
35.  implicit def deprecated mutableSetAsJavaSet[A](s: mutable.Set[A]): java.util.Set[A]
    Definition Classes
      WrapAsJava
36.  implicit def deprecated propertiesAsScalaMap(p: Properties): mutable.Map[String, String]
    Definition Classes
      WrapAsScala
37.  implicit def deprecated seqAsJavaList[A](seq: Seq[A]): java.util.List[A]
    Definition Classes
      WrapAsJava
38.  implicit def deprecated setAsJavaSet[A](s: Set[A]): java.util.Set[A]
    Definition Classes
      WrapAsJava
39.  implicit def dictionaryAsScalaMap[A, B](p: Dictionary[A, B]): mutable.Map[A, B]

    Implicitly converts a Java `Dictionary` to a Scala mutable `Map`.

    Implicitly converts a Java `Dictionary` to a Scala mutable `Map`.

    The returned Scala `Map` is backed by the provided Java `Dictionary` and any side-effects of using it via the Scala interface will be visible via the Java interface and vice versa.

    p

      The Dictionary to be converted.

    returns

      A Scala mutable Map view of the argument.

    Definition Classes
      LowPriorityWrapAsScala
40.  implicit def enumerationAsScalaIterator[A](i: java.util.Enumeration[A]): Iterator[A]

    Implicitly converts a Java Enumeration to a Scala Iterator.

    Implicitly converts a Java Enumeration to a Scala Iterator. The returned Scala Iterator is backed by the provided Java Enumeration and any side-effects of using it via the Scala interface will be visible via the Java interface and vice versa.

    If the Java Enumeration was previously obtained from an implicit or explicit call of `enumerationAsScalaIterator(scala.collection.Iterator)` then the original Scala Iterator will be returned.

    i

      The Enumeration to be converted.

    returns

      A Scala Iterator view of the argument.

    Definition Classes
      LowPriorityWrapAsScala
41.  final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
42.  def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any
43.  def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

44.  final def getClass(): Class[_]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      AnyRef → Any
45.  def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
46.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
47.  implicit def iterableAsScalaIterable[A](i: java.lang.Iterable[A]): Iterable[A]

    Implicitly converts a Java `Iterable` to a Scala `Iterable`.

    Implicitly converts a Java `Iterable` to a Scala `Iterable`.

    The returned Scala `Iterable` is backed by the provided Java `Iterable` and any side-effects of using it via the Scala interface will be visible via the Java interface and vice versa.

    If the Java `Iterable` was previously obtained from an implicit or explicit call of `iterableAsScalaIterable(scala.collection.Iterable)` then the original Scala Iterable will be returned.

    i

      The Iterable to be converted.

    returns

      A Scala Iterable view of the argument.

    Definition Classes
      LowPriorityWrapAsScala
48.  implicit def mapAsJavaConcurrentMap[A, B](m: concurrent.Map[A, B]): ConcurrentMap[A, B]

    Implicitly converts a Scala mutable `concurrent.Map` to a Java `ConcurrentMap`.

    Implicitly converts a Scala mutable `concurrent.Map` to a Java `ConcurrentMap`.

    The returned Java `ConcurrentMap` is backed by the provided Scala `concurrent.Map` and any side-effects of using it via the Java interface will be visible via the Scala interface and vice versa.

    If the Scala `concurrent.Map` was previously obtained from an implicit or explicit call of `mapAsScalaConcurrentMap(java.util.concurrent.ConcurrentMap)` then the original Java ConcurrentMap will be returned.

    m

      The Scala `concurrent.Map` to be converted.

    returns

      A Java `ConcurrentMap` view of the argument.

    Definition Classes
      LowPriorityWrapAsJava
49.  implicit def mapAsJavaMap[A, B](m: Map[A, B]): java.util.Map[A, B]

    Implicitly converts a Scala `Map` to a Java `Map`.

    Implicitly converts a Scala `Map` to a Java `Map`.

    The returned Java `Map` is backed by the provided Scala `Map` and any side-effects of using it via the Java interface will be visible via the Scala interface and vice versa.

    If the Scala `Map` was previously obtained from an implicit or explicit call of `asMap(java.util.Map)` then the original Java `Map` will be returned.

    m

      The `Map` to be converted.

    returns

      A Java `Map` view of the argument.

    Definition Classes
      LowPriorityWrapAsJava
50.  implicit def mapAsScalaConcurrentMap[A, B](m: ConcurrentMap[A, B]): concurrent.Map[A, B]

    Implicitly converts a Java ConcurrentMap to a Scala mutable ConcurrentMap.

    Implicitly converts a Java ConcurrentMap to a Scala mutable ConcurrentMap. The returned Scala ConcurrentMap is backed by the provided Java ConcurrentMap and any side-effects of using it via the Scala interface will be visible via the Java interface and vice versa.

    If the Java ConcurrentMap was previously obtained from an implicit or explicit call of `asConcurrentMap(scala.collection.mutable.ConcurrentMap)` then the original Scala ConcurrentMap will be returned.

    m

      The ConcurrentMap to be converted.

    returns

      A Scala mutable ConcurrentMap view of the argument.

    Definition Classes
      LowPriorityWrapAsScala
51.  implicit def mapAsScalaMap[A, B](m: java.util.Map[A, B]): mutable.Map[A, B]

    Implicitly converts a Java `Map` to a Scala mutable `Map`.

    Implicitly converts a Java `Map` to a Scala mutable `Map`.

    The returned Scala `Map` is backed by the provided Java `Map` and any side-effects of using it via the Scala interface will be visible via the Java interface and vice versa.

    If the Java `Map` was previously obtained from an implicit or explicit call of `mapAsScalaMap(scala.collection.mutable.Map)` then the original Scala Map will be returned.

    If the wrapped map is synchronized (e.g. from `java.util.Collections.synchronizedMap`), it is your responsibility to wrap all non-atomic operations with `underlying.synchronized`. This includes `get`, as `java.util.Map`'s API does not allow for an atomic `get` when `null` values may be present.

    m

      The Map to be converted.

    returns

      A Scala mutable Map view of the argument.

    Definition Classes
      LowPriorityWrapAsScala
52.  implicit def mutableMapAsJavaMap[A, B](m: mutable.Map[A, B]): java.util.Map[A, B]

    Implicitly converts a Scala mutable Map to a Java Map.

    Implicitly converts a Scala mutable Map to a Java Map. The returned Java Map is backed by the provided Scala Map and any side-effects of using it via the Java interface will be visible via the Scala interface and vice versa.

    If the Scala Map was previously obtained from an implicit or explicit call of `asMap(java.util.Map)` then the original Java Map will be returned.

    m

      The Map to be converted.

    returns

      A Java Map view of the argument.

    Definition Classes
      LowPriorityWrapAsJava
53.  implicit def mutableSeqAsJavaList[A](seq: mutable.Seq[A]): java.util.List[A]

    Implicitly converts a Scala mutable Seq to a Java List.

    Implicitly converts a Scala mutable Seq to a Java List. The returned Java List is backed by the provided Scala Seq and any side-effects of using it via the Java interface will be visible via the Scala interface and vice versa.

    If the Scala Seq was previously obtained from an implicit or explicit call of `asSeq(java.util.List)` then the original Java List will be returned.

    seq

      The Seq to be converted.

    returns

      A Java List view of the argument.

    Definition Classes
      LowPriorityWrapAsJava
54.  implicit def mutableSetAsJavaSet[A](s: mutable.Set[A]): java.util.Set[A]

    Implicitly converts a Scala mutable Set to a Java Set.

    Implicitly converts a Scala mutable Set to a Java Set. The returned Java Set is backed by the provided Scala Set and any side-effects of using it via the Java interface will be visible via the Scala interface and vice versa.

    If the Scala Set was previously obtained from an implicit or explicit call of `asSet(java.util.Set)` then the original Java Set will be returned.

    s

      The Set to be converted.

    returns

      A Java Set view of the argument.

    Definition Classes
      LowPriorityWrapAsJava
55.  final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
56.  final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

57.  final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

58.  implicit def propertiesAsScalaMap(p: Properties): mutable.Map[String, String]

    Implicitly converts a Java `Properties` to a Scala `mutable Map[String, String]`.

    Implicitly converts a Java `Properties` to a Scala `mutable Map[String, String]`.

    The returned Scala `Map[String, String]` is backed by the provided Java `Properties` and any side-effects of using it via the Scala interface will be visible via the Java interface and vice versa.

    p

      The Properties to be converted.

    returns

      A Scala mutable Map[String, String] view of the argument.

    Definition Classes
      LowPriorityWrapAsScala
59.  implicit def seqAsJavaList[A](seq: Seq[A]): java.util.List[A]

    Implicitly converts a Scala Seq to a Java List.

    Implicitly converts a Scala Seq to a Java List. The returned Java List is backed by the provided Scala Seq and any side-effects of using it via the Java interface will be visible via the Scala interface and vice versa.

    If the Scala Seq was previously obtained from an implicit or explicit call of `asSeq(java.util.List)` then the original Java List will be returned.

    seq

      The Seq to be converted.

    returns

      A Java List view of the argument.

    Definition Classes
      LowPriorityWrapAsJava
60.  implicit def setAsJavaSet[A](s: Set[A]): java.util.Set[A]

    Implicitly converts a Scala Set to a Java Set.

    Implicitly converts a Scala Set to a Java Set. The returned Java Set is backed by the provided Scala Set and any side-effects of using it via the Java interface will be visible via the Scala interface and vice versa.

    If the Scala Set was previously obtained from an implicit or explicit call of asSet(java.util.Set) then the original Java Set will be returned.

    s

      The Set to be converted.

    returns

      A Java Set view of the argument.

    Definition Classes
      LowPriorityWrapAsJava
61.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
62.  def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any
63.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
64.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
65.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from WrapAsJava

### Inherited from LowPriorityWrapAsJava

### Inherited from WrapAsScala

### Inherited from LowPriorityWrapAsScala

### Inherited from AnyRef

### Inherited from Any

### Ungrouped